##################################################################
#
# (C) Copyright 2006 ObjectRealms, LLC
# All Rights Reserved
#
# This file is part of Bling.
#
# Bling is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Bling is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Bling; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##################################################################
"""A convenience FS object for accessing the bling javascript methods
more easily.

$Id: $
"""
import Globals
from Products.TrustedExecutables.TrustedFSPythonScript import TrustedFSPythonScript
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Products.CMFCore.DirectoryView  import registerFileExtension, registerMetaType
from Products.CMFCore                import permissions
from Products.Bling.pjs import JavascriptPage


# This is a Trusted Python Script, written on the Filesystem
# and not allowing TTW customization. As such it works around issues
# with the chained proxies that implement peejays

class FSJavascript(TrustedFSPythonScript):
    def _exec(self, bound_names, args, kw):
        page = JavascriptPage()
        bound_names.setdefault('page', page)

        # this is an issue when you might want to say
        # <script tal:content="structure here/somePJS"/>
        # we don't want to change the response when included
        # in this way
        # XXX: this check need to be made a little more robust
        if self.REQUEST.URL == self.absolute_url():
            self.REQUEST.RESPONSE.setHeader("Content-Type",
                                            "text/javascript;charset=UTF-8")

        TrustedFSPythonScript._exec(self, bound_names, args, kw)
        return str(page)

    
Globals.InitializeClass(FSJavascript)
registerFileExtension('pjs', FSJavascript)
registerMetaType(FSJavascript.meta_type, FSJavascript)
