import unittest
import sys, os

# Conditional import of
base = ".."
try: base = os.path.abspath(os.path.join(os.path.dirname(__file__), base))
except: pass

sys.path.insert(0, base)
import ajax

class Test(unittest.TestCase):
    def test_bling(self):
        # For now just verify that the code paths function
        # not the acutal output ;)
        assert ajax.linkTo("testMethod", "http://foo.com/bar.py")
        assert ajax.linkTo("updateMethod", "http://foo.com/bar.py",
                          {"update" : "result",
                           "where"  : "top",
                           "submit" : "myForm",
                           })
        assert ajax.linkTo("updateMethod", "http://foo.com/bar.py",
                           {"update" : "result",
                            "where"  : "top",
                            "submit" : "myForm",
                            'confirm' : 'continue with "this"?',
                            })


        assert ajax.linkTo("updateMethod", "http://foo.com/bar.py",
                           {"update" : {"success" : "result",
                                        "failure" : "error"},
                            "where"  : "top",
                            "submit" : "myForm",
                            'confirm' : 'continue with "this"?',
                            })


    def test_bling_form(self):
        assert ajax.remoteForm("http://foo.com/bar.py",
                               {"update" : "result",
                                "where"  : "top",
                                "submit" : "myForm",
                                })

    def test_bling_submit(self):
        assert ajax.submitRemote("http://foo.com/bar.py",
                                 {"update" : "result",
                                  "where"  : "top",
                                  "submit" : "myForm",
                                  })

    def test_escape_js(self):
        js = '''function ()\n\r{\tvar foo="this";}'''
        assert r'\"' in ajax.escape_js(js)

    def test_observeField(self):
        assert ajax.observeField("http://foo/bar.py", "fieldA")
        assert ajax.observeField("http://foo/bar.py",)
        # on success clear errors, on failure notify of them
        assert ajax.observeField("/validate", "foo",
         {'update' : {'success' : 'error', 'failure' : 'error'},
          'success' : ajax.visualEffect('Fade', 'error'),
          'failure' : ajax.visualEffect('Appear', 'error')})

        assert ajax.checkedField('/ajax_validate',
                "foobar", withvalue=True)

    def test_observeForm(self):
        assert ajax.observeForm("http://foo/bar.py", "myform")

    def test_inplace(self):
        assert ajax.BlingEditor("edit.py", 'foo-inplace',
                                js=dict(field_name='foo', rows=15, cols=10))

    def test_refreshArea(self):
        assert ajax.refreshArea('bling_timer', 'timer', js=dict(frequency=10))

    def test_periodicalCall(self):
        assert ajax.periodicalCall(ajax.visualEffect('Highlight', 'thePloneCalender'))

    def test_replacer(self):
        method = ajax.Behavior('a.link', ajax.LinkReplacer('status'))
        # make sure that behavior connected element to the
        # replacement method
        assert 'element' in method
        assert '$element' not in method

    def test_completer(self):
        method = ajax.Behavior('.AT-string-field',
                            ajax.AutoCompleter('$element',
                                               'completer_script'));
        assert '$element' not in method

    def test_jsonify(self):
        @ajax.jsonify
        def foo(**kwargs):
            d = {
                "this": "that",
                1: 2,
                'list' : range(10),
                'tuple' : ('a', 'b', 'c'),
                }
            d.update(kwargs)
            return d
        assert foo(foo="bar")


if __name__=="__main__":
    unittest.main()
